<?php namespace App;

use Illuminate\Database\Eloquent\Model;

class Food extends Model
{
    public $timestamps = false;
    protected $fillable = [
        'name', 'price',
    ];

    public function ingredients()
    {
        return $this->belongsToMany('App\Ingredient')->withPivot('required')->select('id');
    }

    public function menus()
    {
        return $this->belongsToMany('App\Menu');
    }

    public function orders()
    {
        return $this->belongsToMany('App\Order');
    }

    public function toArray(){
      $arr = parent::toArray();
      if (isset($arr['ingredients'])){
        $arr['optionalIngredients'] = [];
        $arr['requiredIngredients'] = [];
        foreach ($arr['ingredients'] as $ingredient){
          if ($ingredient['pivot']['required']){
            $arr['requiredIngredients'][] = $ingredient['id'];
          } else {
            $arr['optionalIngredients'][] = $ingredient['id'];
          }
        }
        unset($arr['ingredients']);
      }
      return $arr;
    }
}
