<?php

namespace App\Http\Middleware;

use Closure;

class RoleAuthenticate
{
    private $keys;

    public function __construct()
    {
        $this->keys = [
          'boss' => $_ENV['APP_BOSS_KEY'],
          'chef' => $_ENV['APP_CHEF_KEY'],
          'waiter' => $_ENV['APP_WAITER_KEY']
        ];
    }

    public function handle($request, Closure $next, $role1, $role2 = null, $role3 = null)
    {
        $authorized = false;
        if ($request->has('key')){
          if ($request->key === $this->keys[$role1]){
            $authorized = true;
          }
          if (!$authorized && ($role2 !== null && $request->key === $this->keys[$role2])){
            $authorized = true;
          }
          if (!$authorized && ($role3 !== null && $request->key === $this->keys[$role3])){
            $authorized = true;
          }
        }

        if (!$authorized) {
            return response('Unauthorized.', 401);
        }

        return $next($request);
    }
}
