<?php namespace App;

use Illuminate\Database\Eloquent\Model;

class Menu extends Model
{
    public $timestamps = false;
    protected $fillable = [
        'name', 'price',
    ];

    public function foods()
    {
        return $this->belongsToMany('App\Food')->select('id');
    }

    public function orders()
    {
        return $this->belongsToMany('App\Order');
    }

    public function toArray(){
      $arr = parent::toArray();
        if (isset($arr['foods'])){
          $foods = [];
          foreach ($arr['foods'] as $food){
            $foods[] = $food['id'];
          }
          $arr['foods'] = $foods;
        }
      return $arr;
    }
}
