<?php namespace App;

use DB;
use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    public $timestamps = false;

    public function toArray(){
      $arr = parent::toArray();
      $foods = DB::table('food_order')->where('order_id', $this->attributes['id'])->get();
      if (count($foods) > 0){
        $arr['foods'] = [];
      }
      foreach ($foods as $food) {
        $foodArr = ['id' => $food->food_id, 'quantity' => $food->quantity];
        $lessIng = DB::table('lessIng_food')->where('food_order_id', $food->id)->get();
        if (count($lessIng) > 0){
          $foodArr['optionalIngredientsRemoved'] = [];
        }
        foreach ($lessIng as $ing) {
          $foodArr['optionalIngredientsRemoved'][] = $ing->ingredient_id;
        }
        $arr['foods'][] = $foodArr;
      }

      $menus = DB::table('menu_order')->where('order_id', $this->attributes['id'])->get();
      if (count($foods) > 0){
        $arr['menus'] = [];
      }
      foreach ($menus as $menu) {
        $menuArr = ['id' => $menu->menu_id, 'quantity' => $menu->quantity];
        $lessIng = DB::table('lessIng_food_menu')->where('menu_order_id', $menu->id)->orderBy('food_id')->get();
        if (count($lessIng) > 0){
          $menuArr['customFoods'] = [];
        }
        $lastFoodId = 0;
        $currentFood = [];
        foreach ($lessIng as $ing) {
          if ($lastFoodId != $ing->food_id){
            if (count($currentFood) > 0){
              $menuArr['customFoods'][] = $currentFood;
            }
            $currentFood = ['id' => $ing->food_id,'optionalIngredientsRemoved' => []];
            $lastFoodId = $ing->food_id;
          }
          $currentFood['optionalIngredientsRemoved'][] = $ing->ingredient_id;
        }
        if (count($currentFood) > 0){
          $menuArr['customFoods'][] = $currentFood;
        }
        $arr['menus'][] = $menuArr;
      }
      return $arr;
    }
}
