<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class FoodIngredient extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('food_ingredient', function (Blueprint $table) {
          $table->integer('food_id')->unsigned();
          $table->integer('ingredient_id')->unsigned();
          $table->boolean('required')->default(true);
          $table->primary(['food_id', 'ingredient_id']);
          $table->foreign('food_id')->references('id')->on('foods')
            ->onDelete('cascade');
          $table->foreign('ingredient_id')->references('id')->on('ingredients')
            ->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('food_ingredient');
    }
}
