<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class FoodMenu extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('food_menu', function (Blueprint $table) {
          $table->integer('food_id')->unsigned();
          $table->integer('menu_id')->unsigned();
          $table->primary(['menu_id', 'food_id']);
          $table->foreign('food_id')->references('id')->on('foods')
            ->onDelete('cascade');
          $table->foreign('menu_id')->references('id')->on('menus')
            ->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('food_menu');
    }
}
