<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class LessIngFoodMenu extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('lessIng_food_menu', function (Blueprint $table) {
          $table->integer('menu_order_id')->unsigned();
          $table->integer('food_id')->unsigned();
          $table->integer('ingredient_id')->unsigned();
          $table->primary(['menu_order_id', 'food_id', 'ingredient_id']);
          $table->foreign('menu_order_id')->references('id')->on('menu_order')
            ->onDelete('cascade');
          $table->foreign('food_id')->references('id')->on('foods')
              ->onDelete('cascade');
          $table->foreign('ingredient_id')->references('id')->on('ingredients')
            ->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('lessIng_food_menu');
    }
}
